pcl::NarfDescriptor Class Reference
Module features

Computes NARF feature descriptors for points in a range image See B. More...

`#include <pcl/features/narf_descriptor.h>`

Inheritance diagram for pcl::NarfDescriptor:

## Classes

struct | Parameters

## Public Types

using | Ptr = shared_ptr< NarfDescriptor >
using | ConstPtr = shared_ptr< const NarfDescriptor >
using | BaseClass = Feature< PointWithRange, Narf36 >
Public Types inherited from pcl::Feature< PointWithRange, Narf36 >
using | BaseClass = PCLBase< PointWithRange >
using | Ptr = shared_ptr< Feature< PointWithRange, Narf36 > >
using | ConstPtr = shared_ptr< const Feature< PointWithRange, Narf36 > >
using | KdTree = pcl::search::Search< PointWithRange >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointWithRange >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< Narf36 >
using | SearchMethod = std::function< int(std::size_t, double, std::vector< int > &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, std::size_t index, double, std::vector< int > &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointWithRange >
using | PointCloud = pcl::PointCloud< PointWithRange >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| NarfDescriptor (const RangeImage *range_image=nullptr, const std::vector< int > *indices=nullptr)
| Constructor. More...
| ~NarfDescriptor ()
| Destructor. More...
void | setRangeImage (const RangeImage *range_image, const std::vector< int > *indices=nullptr)
| Set input data. More...
void | compute (PointCloudOut &output)
| Overwrite the compute function of the base class. More...
Parameters & | getParameters ()
| Get a reference to the parameters struct. More...
Public Member Functions inherited from pcl::Feature< PointWithRange, Narf36 >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointWithRange >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
const PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
const IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
const IndicesConstPtr | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointWithRange & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | computeFeature (PointCloudOut &output) override
| Implementation of abstract derived function. More...
Protected Member Functions inherited from pcl::Feature< PointWithRange, Narf36 >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (std::size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, std::size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointWithRange >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

const RangeImage * | range_image_
Parameters | parameters_
Protected Attributes inherited from pcl::Feature< PointWithRange, Narf36 >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointWithRange >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

Computes NARF feature descriptors for points in a range image See B.

Steder, R. B. Rusu, K. Konolige, and W. Burgard Point Feature Extraction on 3D Range Scans Taking into Account Object Boundaries In Proc. of the IEEE Int. Conf. on Robotics &Automation (ICRA). 2011.

Author
  Bastian Steder

Definition at line 55 of file narf_descriptor.h.

## Member Typedef Documentation

## BaseClass

using pcl::NarfDescriptor::BaseClass = Feature<PointWithRange,Narf36>

Definition at line 61 of file narf_descriptor.h.

## ConstPtr

using pcl::NarfDescriptor::ConstPtr = shared_ptr<const NarfDescriptor>

Definition at line 59 of file narf_descriptor.h.

## Ptr

using pcl::NarfDescriptor::Ptr = shared_ptr<NarfDescriptor>

Definition at line 58 of file narf_descriptor.h.

## Constructor & Destructor Documentation

## NarfDescriptor()

pcl::NarfDescriptor::NarfDescriptor | ( | const RangeImage * | range_image = `nullptr`,
|  | const std::vector< int > * | indices = `nullptr`
| ) |  |

Constructor.

## ~NarfDescriptor()

pcl::NarfDescriptor::~NarfDescriptor | ( |  | ) |

Destructor.

## Member Function Documentation

## compute()

void pcl::NarfDescriptor::compute | ( | PointCloudOut & | output | ) |

Overwrite the compute function of the base class.

## computeFeature()

void pcl::NarfDescriptor::computeFeature | ( | PointCloudOut & | output | ) |

override protected virtual

Implementation of abstract derived function.

Implements pcl::Feature< PointWithRange, Narf36 >.

## getParameters()

Parameters& pcl::NarfDescriptor::getParameters | ( |  | ) |

inline

Get a reference to the parameters struct.

Definition at line 89 of file narf_descriptor.h.

## setRangeImage()

void pcl::NarfDescriptor::setRangeImage | ( | const RangeImage * | range_image,
|  | const std::vector< int > * | indices = `nullptr`
| ) |  |

Set input data.

## Member Data Documentation

## parameters_

Parameters pcl::NarfDescriptor::parameters_

protected

Definition at line 94 of file narf_descriptor.h.

## range_image_

const RangeImage* pcl::NarfDescriptor::range_image_

protected

Definition at line 93 of file narf_descriptor.h.

The documentation for this class was generated from the following file:

- pcl/features/narf_descriptor.h